%Ejemplo de grado de acuerdo SHOUKRI 5.2 sobre la capacidad para
%identificar lesiones de dos mtodos Ultrasonidos y MRL. Las sesiones estn
%estratificadas por el tamao. Aparecen 6 clusters todos de tamao diferemte

%Clculo del estimador del coeficiente de sobredispersin y ro
%Nmero de deteciones para las posibilidades NN NY YN YY mtodos(MRI,U_S)
Y=[40 10 15 20;
    29 10 14 70;
    10 7 7 12;
    3 3 2 24;
    0 1 1 10;
    1 1 2 8];
%Declaramos como variables globales aquellas que van a aparecer en las
  %funciones que llamamos desde este script
  global  W TH0 M M0 Pest;
  clear W TH0 M M0  Pest;
  
[N,M] = size(Y);
%N= numero de tamaos diferentes para los cluster=numero declustres porque
%estamos en el caso de todos los tamaos diferentes
%Tamaos de cada cluster 
nl=sum(Y,2)';

%nmero total de individuos
  n=sum(nl);
 %Inicializamos las Probabilidades para cada cluster 
   Pestl=zeros(size(Y,2),N);
  %Frecuencias relativas por cluster
 for l=1:N
 Pestl(:,l)=(Y(l,:)./nl(l))';
 end;
 % Probabilidad global sin distringuir clusters
 Pest=sum(Y,1)'./n;
 Pmed=sum(Pestl,2)./N;
  nmed=n/N;
  %Calculamos los estimadores de rowh de weir y ron, el introducido en el
 %artculo 

 ETA=(n^2-nl*nl')/((N-1)*n);
 
  MSP=(((Pestl-(repmat(Pest,1,N))).^2)*nl')./(N-1);
 MSG=((Pestl-(Pestl).^2)*nl')./(n-N);
rowh=(sum(MSP-MSG))/(sum(MSP+(MSG.*(ETA-1))));
Nuw=1+(nmed-1)*rowh;
for r=1:M
    if Pest(r)==0
        ronsum(r)=0;
    else
ronsum(r)= sum(((Pestl(r,:)-repmat(Pmed(r),1,N)).^2)*(Pest(r)^(-1)));
    end;
end;
ron=sum(ronsum)/((N-1)*(M-1));
Nu=1+(nmed-1)*ron;
   
% verdadero valor del parmetro utilizado como valor inicial
TH0=[0.1;0.1;-0.1];
% Matriz del modelo loglineal SIN LA TRIPLE  interacin (MODELO (2)
 W=[ 1 1 1;
       1 1 -1;
       1 -1 1;
       1  -1 1];
%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro
M0 = size(W,2);
%Vector de probabilidad estimado mediante modelo loglineal
PTH0=zeros(M,1);
PTH0=exp(W*TH0)/sum(exp(W*TH0));
%Inicializamos las matrices que van a contener las probabilidades estimadas
%y los estimadores de ro

TH=zeros(M0,5);
PTH=zeros(M,5);
SE=zeros(M,5);
 mse=zeros(1,5);

 % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro  
X0 = TH0;
X0(1) = TH0(1)+0.5;
 options = optimset('LargeScale','off');
 %Para cada una de las muestras calculamos el estimador de mnima fidivergencia para theta
for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end
   fidiv=@(x)(sum((Pest.^(land+1))./((exp(W*x)/sum(exp(W*x))).^land)-1)/(land*(land+1)));
fidiv0=@(x)(Pest)'*log(Pest./((exp(W*x))/sum(exp(W*x))));
fidiv1=@(x)((exp(W*x))/sum(exp(W*x)))'*log((exp(W*x))/sum(exp(W*x))./(Pest));

 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,i)= fmincon(fidiv0,X0,[],[],[],[],[],[],restri,options);
  elseif land==-1
   TH(:,i)= fmincon(fidiv1,X0,[],[],[],[],[],[],restri,options);     
  else
    TH(:,i)= fmincon(fidiv,X0,[],[],[],[],[],[],restri,options);
 end; 
PTH(:,i)= (exp(W*TH(:,i)))/sum(exp(W*TH(:,i)));
%CAlculamos el error cuadrtico medio cometido en la estimacin en cada muestra
   mse(1,i)=(TH(:,i)-TH0)'*(TH(:,i)-TH0)/M0;
end


