%Ejemplo de grado de acuerdo SHOUKRI 5.2 sobre la capacidad para
%identificar lesiones de dos mtodos Ultrasonidos y MRL. Las sesiones estn
%stratificadas por el tamao. Aparecen 6 clusters todos de tamao diferemte

%Clculo del estimador del coeficiente de sobredispersin y ro
%Nmero de deteciones para las posibilidades NN NY YN YY mtodos(MRI,U_S)
Y=[40 10 15 20;
    29 10 14 70;
    10 7 7 12;
    3 3 2 24;
    0 1 1 10;
    1 1 2 8];
%Declaramos como variables globales aquellas que van a aparecer en las
  %funciones que llamamos desde este script
  global  W W1 TH0 TH01 M M0 M01 Pest;
  clear W W1 TH0 TH01 M M0 M01 Pest;
 
[N, M] = size(Y);
%N= numero de tamaos diferentes para los cluster=numero declustres porque
%estamos en el caso de todos los tamaos diferentes
%Tamaos de cada cluster 
nl=sum(Y,2)';

%nmero total de individuos
  n=sum(nl);
 
 %Inicializamos las Probabilidades para cada cluster 
  Pestl=zeros(size(Y,2),N);
  %Frecuencias relativas por cluster
 for l=1:N
 Pestl(:,l)=(Y(l,:)./nl(l))';
 end;
 % Probabilidad global sin distringuir clusters
 Pest=sum(Y,1)'./n;
 Pmed=sum(Pestl,2)./N;
  nmed=n/N;
 
  %Calculamos los estimadores de rowh de weir y ron, el introducido en el
 %artculo 

 ETA=(n^2-nl*nl')/((N-1)*n);
 
 MSP=(((Pestl-(repmat(Pest,1,N))).^2)*nl')./(N-1);
 MSG=((Pestl-(Pestl).^2)*nl')./(n-N);
rowh=(sum(MSP-MSG))/(sum(MSP+(MSG.*(ETA-1))));
Nuw=1+(nmed-1)*rowh;
for r=1:M
    if Pest(r)==0
        ronsum(r)=0;
    else
ronsum(r)= sum(((Pestl(r,:)-repmat(Pmed(r),1,N)).^2)*(Pest(r)^(-1)));
    end;
end;
ron=sum(ronsum)/((N-1)*(M-1));
Nu=1+(nmed-1)*ron;
  
% verdadero valor del parmetro utilizado como valor inicial
TH0 =[0.5  ];

% Matriz del modelo loglineal landa (MODELO (1) en donde 
% las coincidencias entre los jueces son debidas al azar

 W =[1; 
     1; 
     1;
     1]; 
    
TH01 =[0.5 ; -0.04 ];

 % Matriz del modelo loglineal en donde incorporamos el grado
 %de acuerdo landa+delta
 % Si rechazamos H0 significa que los dosvjueces estn de acuerdo
 W1 =[1 1 ; 
     1  0 ; 
     1  0 ;
     1  1 ]; 
     
M0=size(W,2);
M01=size(W1,2);

%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro

%Vectores de probabilidad estimados mediante modelo loglineal
PTH0=zeros(M,1);
PTH0=exp(W*TH0)/sum(exp(W*TH0));
PTH01=zeros(M,1);
PTH01=exp(W1*TH01)/sum(exp(W1*TH01));
%Inicializamos las matrices que van a contener las probabilidades estimadas
%y los estimadores de ro

TH=zeros(M0,5);
PTH=zeros(M,5);
SE=zeros(M,5);
 mse=zeros(1,5);
TH1=zeros(M01,5);
PTH1=zeros(M,5);

 % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro 
X0 = TH0;
X0(1) = TH0(1)+0.05; 
X01 = TH01;
X01(1) = TH01(1)+0.05;
 options = optimset('LargeScale','off');
 %Para cada una de las muestras calculamos el estimador de mnima fidivergencia para theta
for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end;
   fiDiv=@(x)(sum((Pest.^(land+1))./((exp(W*x)/sum(exp(W*x))).^land)-1)/(land*(land+1)));
   fiDiv0=@(x)fidiv0(Pest,x,W);
   fiDiv1=@(x)fidiv1(Pest,x,W);

 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 
 fiDiv_1=@(x)(sum((Pest.^(land+1))./((exp(W1*x)/sum(exp(W1*x))).^land)-1)/(land*(land+1)));
   fiDiv0_1=@(x)fidiv0(Pest,x,W1);
   fiDiv1_1=@(x)fidiv1(Pest,x,W1);

 c1=@(x)[(exp(W1*x))/sum(exp(W1*x))-1;
     -(exp(W1*x))/sum(exp(W1*x))];
 ceq =@(x)[];
 restri1=@(x)deal(c1(x),ceq(x));
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,i)= fmincon(fiDiv0,X0,[],[],[],[],[],[],restri,options);
  TH1(:,i)= fmincon(fiDiv0_1,X01,[],[],[],[],[],[],restri1,options);
  elseif land==-1
   TH(:,i)= fmincon(fiDiv1,X0,[],[],[],[],[],[],restri,options); 
   TH1(:,i)= fmincon(fiDiv1_1,X01,[],[],[],[],[],[],restri1,options);
  else
    TH(:,i)= fmincon(fiDiv,X0,[],[],[],[],[],[],restri,options);
     TH1(:,i)= fmincon(fiDiv_1,X01,[],[],[],[],[],[],restri1,options);
 end; 
PTH(:,i)= (exp(W*TH(:,i)))/sum(exp(W*TH(:,i)));
PTH1(:,i)= (exp(W1*TH1(:,i)))/sum(exp(W1*TH1(:,i)));
%CAlculamos el error cuadrtico medio cometido en la estimacin en cada muestra
   mse(1,i)=(TH(:,i)-TH0)'*(TH(:,i)-TH0)/M0;
    for m=1:M
       if Pest(m)==0
           ronsum(m)=0;
            ronsum1(m)=0;
         else
          ronsum(m)= sum(((Pestl(m,:)-repmat(Pmed(m),1,N)).^2)*(PTH(m,i)^(-1))); 
           ronsum1(m)= sum(((Pestl(m,:)-repmat(Pmed(m),1,N)).^2)*(PTH1(m,i)^(-1))); 
       end;
    end;
   ronfi(i)=sum(ronsum)/((N-1)*(M-1));
      Nufi(i)=1+(nmed-1)*ronfi(i);
    ronfi1(i)=sum(ronsum1)/((N-1)*(M-1));
      Nufi1(i)=1+(nmed-1)*ronfi1(i);
    if land==0 
     for m=1:M
       if Pest(m)==0
          Div(m)=0;
       else
        Div(m)=PTH(m)*log(PTH(m)/PTH1(m,i));
       end;
     end;
      DivT(i)=sum(Div);
      T(i)=2*n*DivT(i);
      TB(i)=2*n*DivT(i)/Nufi(i);
    else
      T(i)=2*n*(sum((PTH(:,i).^(land+1))./PTH1(:,i).^land)-1)/(land*(land+1)); 
     TB(i)=2*n*(sum((PTH(:,i).^(land+1))./PTH1(:,i).^land)-1)/(land*(land+1))/Nufi(i);
      end;
 %Observemos que corregimos con el factor de sobredispersin Nu calculado bajo la hiptesis nula 
 pvalor_T(i)= 1-chi2cdf(T(i),1);
  pvalor_TB(i)= 1-chi2cdf(TB(i),1);
 
 end;
