%Simulacin  para el clculo del error cuadrtico medio
%cometido en la estimacin del parmetro theta mediante fi estimadores con
%el modelo de brier para tamaos de cluster variables
%numero de tamaos diferentes para los cluster
G= 3;
%nmero de cluster de cada tamao
C=[18;2;5];
Punt=[0;cumsum(C)];
%el tamao del cluster
n=[5;3;7];
%nmero total de clusters
  TC=sum(C);
  ntot=C'*n;
   %Declaramos comovariables globales aquellas que van a aparecer en las
  %funciones que llamamos desde este script
  global ro2 W TH0 M M0 PTH0 Pest;
  %el coeficiente de dependencia ro2
  %el coeficiente de dependencia ro2
ro2=0.5;
%nmero de muestras a generar
N=10000;
% verdadero valor del parmetro 
TH0=[0.1; 0.2; 0.4 ;0.3 ];
% Matriz del modelo loglineal sin interacin ejemplo de brier(no saturado)
 W=[ 1 0 1 0; 
 1 0 0 1; 
 1 0 -1 -1; 
 0 1 1 0 ;
 0 1 0 1 ;
 0 1 -1 -1; 
 -1 -1 1 0 ;
 -1 -1 0 1 ;
 -1 -1 -1 -1]; 

%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro

[M,M0] = size(W);
PTH0=zeros(M,1);
PTH0=vp(W,TH0);

%Inicializamos las matrices que van a contener las muestras  multinomiales y las probabilidades estimadas

Pest=zeros(M,N);
TH=zeros(M0,N);
PTH=zeros(M,N);
NuB=zeros(N,1);
NuN=zeros(N,1);
NuFi=zeros(N,5);
ro2B=zeros(N,1);
ro2N=zeros(N,1);
ro2Fi=zeros(N,5);
 % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro  
X0 = TH0;
X0(1) = TH0(1)+0.5;

 w=zeros(G,1);
 Np=zeros(G,1);
   % Calculamos los pesos wg de cada tamao cluster
  for g=1:G
   w(g)=n(g)*C(g)/ntot;
  Np(g)=C(g)/TC;
  % Calulamos el tamao medio de un cluster (nest) y el aproximado (nmed)
   nest=w'*n;
  nmed=Np'*n;
  end;
%generamos N muestras formadas por C(g) observaciones de clusters de tamao n(g) a partir de las cuales estimamos las probabilidades
for h=1:N
      ArDat=zeros(TC,M); %valores simulados
      PC=zeros(TC,M); %Probabilidades empricas
      TG=zeros(G,M); %totales en el grupo g para cada valor posible
      nTG=zeros(G,1);
      Pg=zeros(G,M);%Probabilidades medias en cada tipo de cluster
   for g=1:G 
      for j=1:C(g)
    %generamos los vectores de probabilidad mediante dirichlet de parametros
   %a y vp y partir de aqu las multinomiales con dichos vectores
    %Observemos que cada fila de ArDat es una muestra de valores de un cluster
    ArDat(Punt(g)+j,:)=rclump(ro2,PTH0,n(g));
    PC(Punt(g)+j,:)=ArDat(Punt(g)+j,:)/n(g);
       end;
    TG(g,:)=sum(ArDat(Punt(g)+1:(Punt(g)+C(g)),:));
     nTG(g)=n(g)*C(g);
     %CAlculamos el estimador no parametrico de la probalidad para
     %los cluster de igual tamao
       Pg(g,:)=TG(g,:)/nTG(g);
   end;
   %Probabilidades globales  sin diferenciar clusters
   Pest(:,h)=sum(TG,1)'./ntot;
   
    %Estimadores del parmetro de sobredispersin y de ro de Brier y nuevos
   %estimadores NuN semiparamtricos
   Difv=zeros(TC,M);
   %Para el estimador de Brier
   ChiBv=zeros(TC,M);
    ChiB=zeros(G,1);
   NuBg=zeros(G,1);
   %Para el nuevo estimador utilizando la probabilidad emprica
   ChiNv=zeros(TC,M);
   ChiN=zeros(G,1);
   NuNg=zeros(G,1);
   %Utilizando fi-divergencias
   ChiFiv=zeros(TC,1);
   ChiFi=zeros(G,1);
   NuFig=zeros(G,1);
   
  for g=1:G 
    for j=1:C(g)
        Difv(Punt(g)+j,:)= ((PC(Punt(g)+j,:)-Pg(g,:))).^2;
      for m=1:M
        if Pg(g,m)==0;
             ChiBv(Punt(g)+j,m)=0;
         else
        ChiBv(Punt(g)+j,m)=Difv((Punt(g)+j),m)/Pg(g,m);
       end;
       
       if Pest(m,h)==0;
             ChiNv(Punt(g)+j,m)=0;
         else
        ChiNv(Punt(g)+j,m)=Difv((Punt(g)+j),m)/Pest(m,h);
       end;
      end;
    end;
  end;
   %Sumamos desde j=1 hasta M
  SChiBv=sum(ChiBv,2);
  SChiNv=sum(ChiNv,2);
    %sumamos a traves de los clusters  
  for g=1:G
     ChiB(g)=sum(SChiBv(Punt(g)+1:Punt(g)+C(g)))*n(g); 
     ChiN(g)=sum(SChiNv(Punt(g)+1:Punt(g)+C(g)))*n(g); 
   end;
  NuBg=ChiB./((C-1)*(M-1));
  NuB(h)=NuBg'*w;
  ro2B(h)=(NuB(h)-1)/(nmed-1);
  if ro2B(h)<0; ro2B(h)=0;
  elseif ro2B(h)>1; ro2B(h)=1;
  end;
   
   NuNg=ChiN./((C-1)*(M-1));
  NuN(h)=NuNg'*w;
  ro2N(h)=(NuN(h)-1)/(nmed-1);
  if ro2N(h)<0; ro2N(h)=0;
  elseif ro2N(h)>1; ro2N(h)=1;
  end;
  
  %Errores y sesgos
  %Inicializamos los vectores que van acontener los sesgos y RMSE
  %delosdiferntes estimadores
  msero2=zeros(1,7);
  rmsero2=zeros(1,7);
   sgro2=zeros(1,7);
   mseTH=zeros(1,5);
  rmseTH=zeros(1,5);
  %Errores y sesgos de ro2
  msero2(1)=(ro2B-ro2)'*(ro2B-ro2)/h;
  rmsero2(1)=sqrt(msero2(1));
  sgro2(1)=sum(ro2B)/h-ro2;
  msero2(2)=(ro2N-ro2)'*(ro2N-ro2)/h;
  rmsero2(2)=sqrt(msero2(2));
  sgro2Fi(2)=sum(ro2N)/h-ro2;
  
  %Para cada una de las muestras calculamos el estimador de mnima
 %fidivergencia  para los siguientes valores de landa y el estimador de ro
  
 options = optimset('LargeScale','off');
 
for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end;

  fiDiv=@(x)(sum((Pest(:,h).^(land+1))./vp(W,x).^land)-1)/(land*(land+1));
 fiDiv0=@(x)fidiv0(Pest(:,h),x,W);
 fiDiv1=@(x)fidiv1(Pest(:,h),x,W);

 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,h)= fmincon(fiDiv0,X0,[],[],[],[],[],[],restri,options);
  elseif land==-1
   TH(:,h)= fmincon(fiDiv1,X0,[],[],[],[],[],[],restri,options);     
  else
    TH(:,h)= fmincon(fiDiv,X0,[],[],[],[],[],[],restri,options);
 end; 
PTH(:,h)=vp(W,TH(:,h)) ;
%Con la probabilidad estimada mediante el modelologlineal y fi-divergencia
%claculamos el estimador de ropara cada uno delos valores de landa
  for g=1:G 
    for j=1:C(g) 
     for m=1:M;
       if PTH(m,h)==0;
             ChiFiv(Punt(g)+j,m)=0;
         else
        ChiFiv(Punt(g)+j,m)=Difv((Punt(g)+j),m)/PTH(m,h);
       end;
     end;
    end;
  end;
  SChiFiv=sum(ChiFiv,2);
    
  for g=1:G
     ChiFi(g)=sum(SChiFiv(Punt(g)+1:Punt(g)+C(g)))*n(g);
  end;
  
  NuFig=ChiFi./((C-1)*(M-1));
  NuFi(h,i)=NuFig'*w;
  ro2Fi(h,i)=(NuFi(h,i)-1)/(nmed-1);
  if ro2Fi(h,i)<0; ro2Fi(h,i)=0;
  elseif ro2Fi(h,i)>1; ro2Fi(h,i)=1;
  end;
  
  msero2(2+i)=(ro2Fi(:,i)-ro2)'*(ro2Fi(:,i)-ro2)/h;
   rmsero2(2+i)=sqrt(msero2(2+i));
  sgro2(2+i)=sum(ro2Fi(:,i)-ro2)/h;
  mseTH(i)=(TH(:,h)-TH0)'*(TH(:,h)-TH0)/h;
  rmseTH(i)=sqrt(mseTH(i));
end;
end;

  figure(1);
boxplot([ro2B,ro2N,ro2Fi], 'labels',{'Brier','Nuevo','-0.5','0','2/3','1','2'});
 %CAlculamos el error cuadrtico medio cometido en la estimacin en cada muestra
 
 


