%Simulacin  para el clculo del RMSE cometido en la estimacin de ro2 
%mediante lo estimadores rowh de Weir y ron (el introducido en el
 %artculo para el modelo saturado) para cada una de las variables D3,
 %VGA,FGA y D8 con datos generados con una Dirichlet Multinomial 
 %para tamaos de cluster variables

%nmero de tamaos diferentes para los cluster
G=6 ;
%nmero de cluster de cada tamao
C=[1;1;1;1;1;1];
%variable indicador del cluster
Punt=[0;cumsum(C)];
%el tamao del cluster
global ro2  M PTH0 Pest;  
%nmero total de clusters
  TC=sum(C);
  %nmero total de unidades muestrales,n esel vector que contiene el nmero
  %de unidades de cada cluster
  ntot=C'*n;
  %Constante que aproxima el tamao muestral medio introducida por weir
 ETA=(ntot^2-n'*n)/((TC-1)*ntot);  
  %Declaramos como variables globales aquellas que van a aparecer en las
  %funciones que llamamos desde este script
 %nmero de muestras a generar
N=10000;
 % locus pfga  Distribucin rc
%Inicializamos las matrices que van a contener las muestras simuladas y las probabilidades estimadas
PTH0=PvWA;
M=size(PTH0,1);
Pest=zeros(M,N);
rowh=zeros(N,1);
nu=zeros(N,1);
ron=zeros(N,1);
 %Inicializamos los vectores que van acontener los RMSE de los diferentes estimadores
  msero2=zeros(39,2);
  rmsero2=zeros(39,2);
 sgro2=zeros(39,2);
 
  for r=1:39;
   ro2=2.5*r/1000;
   a=PTH0*(1-ro2)/ro2; 
%generamos N muestras formadas por C(g) observaciones de clusters de tamao n(g) a partir de las cuales estimamos las probabilidades
for h=1:N
      ArDat=zeros(TC,M); %valores simulados
      PC=zeros(TC,M); %Probabilidades empricas
      TG=zeros(G,M); %totales en el grupo g para cada valor posible
      nTG=zeros(G,1);
      Pg=zeros(G,M);%Probabilidades medias en cada tipo de cluster(en este caso coinciden con las probailidades del cluster porque solo hay uno por grupo 
   for g=1:G 
      for j=1:C(g)
    %no olvidemos que en este caso C(g)=1 
    %generamos los vectores de probabilidad mediante ninflada de parametros
   %a y PTH0 y partir de aqu las multinomiales con dichos vectores
    %Observemos que cada fila de ArDat es una muestra de valores de un cluster
    ArDat(Punt(g)+j,:)=n_inf(ro2,PTH0,n(g));
    PC(Punt(g)+j,:)=ArDat(Punt(g)+j,:)/n(g);
       end;
    TG(g,:)=sum(ArDat(Punt(g)+1:(Punt(g)+C(g)),:));
     nTG(g)=n(g)*C(g);
     %CAlculamos el estimador no parametrico de la probabilidad para
     %los cluster de igual tamao
       Pg(g,:)=PC(g,:);
   end;
   %Probabilidades globales  sin diferenciar clusters
   Pest(:,h)= Pg'*n./ntot;
   
    %Calculamos los estimadores de rowh de weir y ron el introducido en el
 %artculo para cada una de las variables
 
 MSP=(n'*((Pg(:,:)-(repmat(Pest(:,h),1,G)')).^2))./(TC-1);
 MSG=(n'*(Pg(:,:)-(Pg(:,:)).^2))./(ntot-TC);
rowh(h)=(sum(MSP-MSG))/(sum(MSP+(MSG.*(ETA-1))));
% hacemos el sumando cero cuando la probablidad es cero para evitar la divisin
% por cero
sumron=zeros(1,M);
for m=1:M
 if Pest(m,h)==0;
          sumron(m)=0;
         else
        sumron(m)= sum(((Pg(:,m)-(sum(Pg(:,m))./TC)).^2))/Pest(m,h);
 end;
end;
ron(h)= sum(sumron)/((TC-1)*(M-1));
  
  %Errores cuadrticos medios de ron (col 1) y de rowh (col 2)
   msero2(r,1)=(ron-ro2)'*(ron-ro2)/h;
    sgro2(r,1)=sum(ron)/h-ro2;
  rmsero2(r,1)=sqrt(msero2(r,1));
  msero2(r,2)=(rowh-ro2)'*(rowh-ro2)/h;
  sgro2(r,2)=sum(rowh)/h-ro2;
  rmsero2(r,2)=sqrt(msero2(r,2));
end;
  end;




