%Simulacin  para el clculo de los niveles de significacin y potencia 
%para el contraste de bondad de ajuste para tamaos de cluster diferentes
%el numero de grupos de clusters
G= 3;
%nmero de cluster de cada tamao
C=[18;2;5];
Punt=[0;cumsum(C)];
%el tamao del cluster
n=[5;3;7];
%nmero total de clusters
  TC=sum(C);
  ntot=C'*n;
  %Declaramos como variables globales aquellas que van a aparecer en las
  %funciones que llamamos desde este script
  global ro2 W TH0 M M0 PTH0 Pest;
  %el coeficiente de dependencia ro2
 
%nmero de muestras a generar
N=10;
% verdadero valor del parmetro 
TH0=[0.1; 0.2; 0.4 ;0.3 ];
% Matriz del modelo loglineal sin interacin ejemplo de brier(no saturado)
W=[ 1 0 1 0; 
 1 0 0 1; 
 1 0 -1 -1; 
 0 1 1 0 ;
 0 1 0 1 ;
 0 1 -1 -1; 
 -1 -1 1 0 ;
 -1 -1 0 1 ;
 -1 -1 -1 -1]; 


%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro

[M,M0] = size(W);
PTH0=zeros(M,1);
PTH0=vp(W,TH0);

%Inicializamos las matrices que van a contener las muestras  multinomiales y las probabilidades estimadas

Pest=zeros(M,N);
TH=zeros(M0,N);
PTH=zeros(M,N,5);
ChiTH=zeros(TC,M,5); 
alfaT=zeros(5,5,39);
alfaTB=zeros(5,5,39);
alfaTSC=zeros(5,5,39);
sumalfaT=zeros(5,5,39);
sumalfaTB=zeros(5,5,39);
sumalfaTSC=zeros(5,5,39);
alfaT2=zeros(5,5,39);
alfaTB2=zeros(5,5,39);
alfaTSC2=zeros(5,5,39);
sumalfaT2=zeros(5,5,39);
sumalfaTB2=zeros(5,5,39);
sumalfaTSC2=zeros(5,5,39);
 % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro  
X0 = TH0;
X0(1) = TH0(1)+0.5;

 w=zeros(G,1);
 Np=zeros(G,1);
   % Calculamos los pesos wg de cada tamao cluster
  for g=1:G
   w(g)=n(g)*C(g)/ntot;
  Np(g)=C(g)/TC;
  % Calulamos el tamao medio de un cluster (nest) y el aproximado (nmed)
   nest=w'*n;
  nmed=Np'*n;
  end;
  for r=1:39
    ro2=2.5*r/100;
   a=PTH0*(1-ro2)/ro2; 
%generamos N muestras formadas por C(g) observaciones de clusters de tamao n(g) a partir de las cuales estimamos las probabilidades
for h=1:N
      ArDat=zeros(TC,M); %valores simulados
      PC=zeros(TC,M); %Probabilidades empricas
      TG=zeros(G,M); %totales en el grupo g para cada valor posible
      nTG=zeros(G,1);
      Pg=zeros(G,M);%Probabilidades medias en cada tipo de cluster
   for g=1:G 
      for j=1:C(g)
    %generamos los vectores de probabilidad mediante dirichlet de parametros
   %a y PTH0 y partir de aqu las multinomiales con dichos vectores
    %Observemos que cada fila de ArDat es una muestra de valores de un cluster
    ArDat(Punt(g)+j,:)=rclump(ro2,PTH0,n(g));
    PC(Punt(g)+j,:)=ArDat(Punt(g)+j,:)/n(g);
      end;
    TG(g,:)=sum(ArDat(Punt(g)+1:(Punt(g)+C(g)),:));
     nTG(g)=n(g)*C(g);
     %CAlculamos el estimador no parametrico de la probalidad para
     %los cluster de igual tamao
       Pg(g,:)=TG(g,:)/nTG(g);
   end;
   %Probabilidades globales  sin diferenciar clusters
   Pest(:,h)=sum(TG,1)'./ntot;
   
    %Estimadores del parmetro de sobredispersin y de ro de Brier y nuevos
   %estimadores NuN semiparamtricos
   Difv=zeros(TC,M);
   %Para el estimador de Brier
   ChiBv=zeros(TC,M);
    ChiB=zeros(G,1);
   NuBg=zeros(G,1);
   %Para el nuevo estimador utilizando la probabilidad emprica
   ChiNv=zeros(TC,M);
   ChiN=zeros(G,1);
   NuNg=zeros(G,1);
   %Utilizando fi-divergencias
   ChiFiv=zeros(TC,1);
   ChiFi=zeros(G,1);
   NuFig=zeros(G,1);
   
  for g=1:G 
    for j=1:C(g)
        Difv(Punt(g)+j,:)= ((PC(Punt(g)+j,:)-Pg(g,:))).^2;
      for m=1:M
        if Pg(g,m)==0;
             ChiBv(Punt(g)+j,m)=0;
         else
        ChiBv(Punt(g)+j,m)=Difv((Punt(g)+j),m)/Pg(g,m);
       end;
              if Pest(m,h)==0;
             ChiNv(Punt(g)+j,m)=0;
              else
         ChiNv(Punt(g)+j,m)=Difv((Punt(g)+j),m)/Pest(m,h);
           end;
      end;
    end;
  end;
  %Sumamos desde j=1 hasta M
  SChiBv=sum(ChiBv,2);
  SChiNv=sum(ChiNv,2);
   %sumamos a traves de los clusters  
  for g=1:G
     ChiB(g)=sum(SChiBv(Punt(g)+1:Punt(g)+C(g)))*n(g); 
     ChiN(g)=sum(SChiNv(Punt(g)+1:Punt(g)+C(g)))*n(g); 
   end;
  NuBg=ChiB./((C-1)*(M-1));
  NuB=NuBg'*w;
     
    NuNg=ChiN./((C-1)*(M-1));
  NuN=NuNg'*w;
  
  %Para cada una de las muestras calculamos el estimador de mnima
 %fidivergencia  para los siguientes valores de landa y el estimador de ro
   
 options = optimset('LargeScale','off');
 
for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end;
  
 fiDiv=@(x)(sum((Pest(:,h).^(land+1))./vp(W,x).^land)-1)/(land*(land+1));
 fiDiv0=@(x)fidiv0(Pest(:,h),x,W);
 fiDiv1=@(x)fidiv1(Pest(:,h),x,W);

 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,h)= fmincon(fiDiv0,X0,[],[],[],[],[],[],restri,options);
  elseif land==-1
   TH(:,h)= fmincon(fiDiv1,X0,[],[],[],[],[],[],restri,options);     
  else
    TH(:,h)= fmincon(fiDiv,X0,[],[],[],[],[],[],restri,options);
 end; 
PTH(:,h,i)= vp(W,TH(:,h));
%Con la probabilidad estimada mediante el modelo loglineal y los estimadores de m fi-divergencia
%calculamos el estimador de ro para cada uno de los valores de landa
  for g=1:G 
    for j=1:C(g) 
     for m=1:M;
       if PTH(m,h,i)==0;
             ChiFiv(Punt(g)+j,m)=0;
         else
        ChiFiv(Punt(g)+j,m)=Difv((Punt(g)+j),m)/PTH(m,h,i);
       end;
     end;
    end;
  end;
  SChiFiv=sum(ChiFiv,2);
    
  for g=1:G
     ChiFi(g)=sum(SChiFiv(Punt(g)+1:Punt(g)+C(g)))*n(g);
  end;
  
  NuFig=ChiFi./((C-1)*(M-1));
  NuFi(i)=NuFig'*w;
  Nu=[NuB NuFi]; %vector que contiene los estimadores de Nu de Brier y semiparamtrico
 end; 
 for j=1:5
  for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end;
     
 if land==0 
     for m=1:M
       if Pest(m,h)==0
          Div(m)=0;
         else
        Div(m)=Pest(m,h)*log(Pest(m,h)/PTH(m,h,j));
       end;
     end;
      T(i,j)=2*ntot*sum(Div)/Nu(j+1);
      TB(i,j)=2*ntot*sum(Div)/Nu(1);
      TSC(i,j)=2*ntot*sum(Div);
  else
     T(i,j)=2*ntot*(sum((Pest(:,h).^(land+1))./PTH(:,h,j).^land)-1)/(land*(land+1))/Nu(j+1); 
     TB(i,j)=2*ntot*(sum((Pest(:,h).^(land+1))./PTH(:,h,j).^land)-1)/(land*(land+1))/Nu(1); 
      TSC(i,j)=2*ntot*(sum((Pest(:,h).^(land+1))./PTH(:,h,j).^land)-1)/(land*(land+1)); 
 end;   
 
   if T(i,j)>chi2inv(0.95,M-M0-1) IalfaT(i,j)=1; else IalfaT(i,j)=0;end;
 sumalfaT(i,j,r)= sumalfaT(i,j,r)+IalfaT(i,j);
  if T(i,j)>chi2inv(0.90,M-M0-1) IalfaT2(i,j)=1; else IalfaT2(i,j)=0;end;
 sumalfaT2(i,j,r)= sumalfaT2(i,j,r)+IalfaT2(i,j);
 
 if TB(i,j)>chi2inv(0.95,M-M0-1) IalfaTB(i,j)=1; else IalfaTB(i,j)=0;end;
 sumalfaTB(i,j,r)= sumalfaTB(i,j,r)+IalfaTB(i,j);
 if TB(i,j)>chi2inv(0.90,M-M0-1) IalfaTB2(i,j)=1; else IalfaTB2(i,j)=0;end;
 sumalfaTB2(i,j,r)= sumalfaTB2(i,j,r)+IalfaTB2(i,j);
 
 if TSC(i,j)>chi2inv(0.95,M-M0-1) IalfaTSC(i,j)=1; else IalfaTSC(i,j)=0;end;
 sumalfaTSC(i,j,r)= sumalfaTSC(i,j,r)+IalfaTSC(i,j);
 
 if TSC(i,j)>chi2inv(0.90,M-M0-1) IalfaTSC2(i,j)=1; else IalfaTSC2(i,j)=0;end;
 sumalfaTSC2(i,j,r)= sumalfaTSC2(i,j,r)+IalfaTSC2(i,j);
 
 alfaT(i,j,r)=sumalfaT(i,j,r)/N;
  alfaTB(i,j,r)=sumalfaTB(i,j,r)/N;
 alfaTSC(i,j,r)=sumalfaTSC(i,j,r)/N; 
 alfaT2(i,j,r)=sumalfaT2(i,j,r)/N;
  alfaTB2(i,j,r)=sumalfaTB2(i,j,r)/N;
 alfaTSC2(i,j,r)=sumalfaTB2(i,j,r)/N; 
  
  
end;
end;

  end;


   end;

  
