%Simulacin  para el clculo de la potencia 
%para el contraste de bondad de ajuste para tamaos de cluster constantes
%el tamao del cluster
n=2;
%nmero total de clusters
 TC=71;
 ntot=n*TC;
  %Declaramos como ariables globales aquellas que van a aparecer en las
  %funciones que llamamos desde este script
  global ro2 W TH0 M M0 PTH0 Pest;
  clear ro2 W TH0 M M0 PTH0 Pest;
  
%nmero de muestras a generar
N=10000;
% verdadero valor del parmetro para el modelo de independencia 
TH0=[-0.05;-0.18];
% Matriz del modelo loglineal sin interacin (no saturado)
W=[1 1;  
  1 -1; 
  -1 1; 
 -1 -1];

%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro
[M,M0] = size(W);
PTH0=zeros(M,1);
PTH1=zeros(M,1);
PTH0=vp(W,TH0);

%Inicializamos las matrices que van a contener las probabilidades estimadas
%y los errores

Pest=zeros(M,N);
TH=zeros(M0,N);
PTH=zeros(M,N,5);
ChiTH=zeros(TC,M,5);
ChiN=zeros(1,M);
T=zeros(5,5);
TB=zeros(5,5);
TSC=zeros(5,5);
Nu=zeros(N,6);
BetaT=zeros(5,5,19,19);
BetaTB=zeros(5,5,19,19);
BetaTSC=zeros(5,5,19,19);
IalfaT=zeros(5,5);
IalfaTB=zeros(5,5);
IalfaTSC=zeros(5,5);
sumBetaT=zeros(5,5,19,19);
sumBetaTB=zeros(5,5,19,19);
sumBetaTSC=zeros(5,5,19,19);

  % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro  
X0 = TH0;
X0(1) = TH0(1)+0.5;

 for r=1:19
     ro2=5*r/100;
  for d=1:19 
      delta=5*r/100;
     PTH1=(PTH0+delta*[1 0 0 1]')/(1+2*delta); 
   a=PTH1*(1-ro2)/ro2; 
%generamos N muestras formadas por C(g) observaciones de clusters de tamao
%n(g) a partir de las probabilidades PTH1 con diferentes delta para encontrar la potencia del
%contraste, es decir probabilidad de rechazar la hiptesisi nula cuando es
%falsa
  for h=1:N
    ArDat=zeros(TC,M); %valores simulados
      pm=zeros(TC,M); %Probabilidades empricas para cada cluster
     %generamos los vectores de probabilidad mediante dirichlet de parmetros
   %a y PTH0 y partir de aqu las multinomiales con dichos vectores
    %Observemos que cada fila de ArDat es una muestra de valores de un cluster
  for l=1:TC 
       ArDat(l,:)=Dirnd(ro2,a,n);
     %Calculamos el vector de probabilidad estimado para cada cluster pm  
       pm(l,:)=ArDat(l,:)/n;
  end; 
  Pest(:,h)=sum(ArDat,1)'./ntot;
    
  %Para cada una de las muestras calculamos el estimador de mnima
 %fi-divergencia  para los siguientes valores de landa y el estimador de ro
   
 options = optimset('LargeScale','off');
 
for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end;
  
 fiDiv=@(x)(sum((Pest(:,h).^(land+1))./vp(W,x).^land)-1)/(land*(land+1));
 fiDiv0=@(x)(Pest(:,h)'*log(Pest(:,h)./vp(W,x)));
 fiDiv1=@(x)fidiv1(Pest(:,h),x,W);

 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 if land==0 
      %llamamos a la funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,h)= fmincon(fiDiv0,X0,[],[],[],[],[],[],restri,options);
  elseif land==-1
   TH(:,h)= fmincon(fiDiv1,X0,[],[],[],[],[],[],restri,options);     
  else
    TH(:,h)= fmincon(fiDiv,X0,[],[],[],[],[],[],restri,options);
  end; 
PTH(:,h,i)= vp(W,TH(:,h));
end; 
for l=1:TC 
         Difv(l,:)= ((pm(l,:)-Pest(:,h)')).^2;
  
% Para evitar la divisin por cero sustituimos el sumando por su valor
 for j=1:5 
   for m=1:M 
       if PTH(m,h,j)==0
             ChiTH(l,m,j)=0;   
       else
          ChiTH(l,m,j)=Difv(l,m)/PTH(m,h,j);
       end;
    
        if Pest(m,h)==0
             ChiN(l,m)=0;
        else
            ChiN(l,m)=Difv(l,m)/Pest(m,h);
        end;  
    end;
 %Con la probabilidad estimada mediante el modelo loglineal y los estimadores de m fi-divergencia
%calculamos el estimador de ro para cada uno de los valores de landa
    %Sumamos desde j=1 hasta M
  Nu(h,1)=(sum(sum(ChiN))*n)/((TC-1)*(M-1));
  Nu(h,j+1)=(sum(sum(ChiTH(:,:,j)))*n)/((TC-1)*(M-1));
  
 end;
end;

 for j=1:5
  for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end;
   
 if land==0 
     T(i,j)=2*ntot*(Pest(:,h)'*log(Pest(:,h)./PTH(:,h,j)))/Nu(j+1);
   TB(i,j)=2*ntot*(Pest(:,h)'*log(Pest(:,h)./PTH(:,h,j)))/Nu(1);
   %Estadsticos sin corregir por el efecto del diseo
  TSC(i,j)=2*ntot*(Pest(:,h)'*log(Pest(:,h)./PTH(:,h,j))); 
        
    else
     T(i,j)=2*ntot*(sum((Pest(:,h).^(land+1))./PTH(:,h,j).^land)-1)/(land*(land+1))/Nu(j+1); 
     TB(i,j)=2*ntot*(sum((Pest(:,h).^(land+1))./PTH(:,h,j).^land)-1)/(land*(land+1))/Nu(1); 
   %Estadsticos sin corregir por el efecto del diseo
  TSC(i,j)=2*ntot*(Pest(:,h)'*log(Pest(:,h)./PTH(:,h,j))); 
 end; 
  if T(i,j)>chi2inv(0.95,M-M0-1) IBetaT(i,j)=1; else IBetaT(i,j)=0;end;
  sumBetaT(i,j,r,d)= sumBetaT(i,j,r,d)+IBetaT(i,j);
   
 if TB(i,j)>chi2inv(0.95,M-M0-1) IBetaTB(i,j)=1; else IBetaTB(i,j)=0;end;
 sumBetaTB(i,j,r,d)= sumBetaTB(i,j,r,d)+IBetaTB(i,j);
 
 if TSC(i,j)>chi2inv(0.95,M-M0-1) IBetaT(i,j)=1; else IBetaT(i,j)=0;end;
 sumBetaTSC(i,j,r,d)= sumBetaTSC(i,j,r,d)+IBetaT(i,j);
 

 BetaT(i,j,r,d)=sumBetaT(i,j,r,d)/N;
  BetaTB(i,j,r,d)=sumBetaTB(i,j,r,d)/N;
 BetaTSC(i,j,r,d)=sumBetaTSC(i,j,r,d)/N; 
 
  
   end;
   end;
   end;
  end;
  end;
 
