%Simulacin  de estimadores para ro2=0.5
%el modelo de Brier para tamaos de cluster constantes
%el tamao del cluster
n=5;
%nmero total de clusters N=TC
 TC=71;
 ntot=n*TC;
  %Declaramos como variables globales aquellas que van a aparecer en las
  %funciones que llamamos desde este script
  global ro2 W TH0 M M0 PTH0 Pest;
  
%nmero de muestras a generar
N=10000;
% verdadero valor del parmetro 
TH0=[-0.06;-0.18];
% Matriz del modelo loglineal sin interaccin (no saturado)
W=[1 1;  
  1 -1; 
  -1 1; 
 -1 -1];

%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro
[M,M0] = size(W);
PTH0=zeros(M,1);
PTH0=vp(W,TH0);

%Inicializamos las matrices que van a contener las probabilidades estimadas
%y los errores

Pest=zeros(M,N);
TH=zeros(M0,N);
mseTHv=zeros(M0,1);
PTH=zeros(M,N,5);
ro2Est=zeros(N,6);
rmsero2M=zeros(19,6);
rmseTHM=zeros(19,5);
sgro2M=zeros(19,6);
 ChiTH=zeros(TC,M,5); 
 
  % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro  
X0 = TH0;
X0(1) = TH0(1)+0.5;

  
     ro2=0.25;
   a=PTH0*(1-ro2)/ro2; 
%generamos N muestras formadas por C(g) observaciones de clusters de tamao n(g) a partir de las cuales estimamos las probabilidades
for h=1:N
    ArDat=zeros(TC,M); %valores simulados
      pm=zeros(TC,M); %Probabilidades empricas para cada cluster
     %generamos los vectores de probabilidad mediante dirichlet de parmetros
   %a y PTH0 y partir de aqu las multinomiales con dichos vectores
    %Observemos que cada fila de ArDat es una muestra de valores de un cluster
  for l=1:TC 
       ArDat(l,:)=n_inf(ro2,PTH0,n);
     %Calculamos el vector de probabilidad estimado para cada cluster pm  
       pm(l,:)=ArDat(l,:)/n;
  end; 
  Pest(:,h)=sum(ArDat,1)'./ntot;
    
  %Para cada una de las muestras calculamos el estimador de mnima
 %fi-divergencia  para los siguientes valores de landa y el estimador de ro
   
 options = optimset('LargeScale','off');
 
for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end;
  
 fiDiv=@(x)(sum((Pest(:,h).^(land+1))./vp(W,x).^land)-1)/(land*(land+1));
 fiDiv0=@(x)fidiv0(Pest(:,h),x,W);
 fiDiv1=@(x)fidiv1(Pest(:,h),x,W);

 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,h)= fmincon(fiDiv0,X0,[],[],[],[],[],[],restri,options);
  elseif land==-1
   TH(:,h)= fmincon(fiDiv1,X0,[],[],[],[],[],[],restri,options);     
  else
    TH(:,h)= fmincon(fiDiv,X0,[],[],[],[],[],[],restri,options);
  end; 
PTH(:,h,i)= vp(W,TH(:,h));
end; 
for l=1:TC 
         Difv(l,:)= ((pm(l,:)-Pest(:,h)')).^2;
  
% Para evitar la divisin por cero sustituimos el sumando por su valor
 for j=1:5 
   for m=1:M 
       if PTH(m,h,j)==0
             ChiTH(l,m,j)=0;   
       else
          ChiTH(l,m,j)=Difv(l,m)/PTH(m,h,j);
       end;
    
        if Pest(m,h)==0
             ChiN(l,m)=0;
        else
            ChiN(l,m)=Difv(l,m)/Pest(m,h);
        end;  
    end;
 %Con la probabilidad estimada mediante el modelo loglineal y los estimadores de m fi-divergencia
%calculamos el estimador de ro para cada uno de los valores de landa
    %Sumamos desde j=1 hasta M
  Nu(h,1)=(sum(sum(ChiN))*n)/((TC-1)*(M-1));
  Nu(h,j+1)=(sum(sum(ChiTH(:,:,j)))*n)/((TC-1)*(M-1));
 end;
end;
  for t=1:6
  ro2Est(h,t)=(Nu(h,t)-1)/(n-1);
   if ro2Est(h,t)<0; ro2Est(h,t)=0;
    elseif ro2Est(h,t)>1; ro2Est(h,t)=1;
   end;
   msero2Est(t)=(ro2-ro2Est(:,t))'*(ro2-ro2Est(:,t))/h;
   rmsero2Est(t)=sqrt(msero2Est(t));
   sgro2(:,t)=sum(ro2Est(:,t))/h-ro2;
  end; 
  end;
  